clc
close all

imgDir=fullfile(pwd,'TrainData');
labelDir = fullfile(pwd,'TrainLabel');
imds=imageDatastore(imgDir);
classes = ["nroi","roi"];
labelIDs=[0  255];
pxds=pixelLabelDatastore(labelDir,classes,labelIDs);
I=read(imds);
C=read(pxds);
K=imread(pxds.Files{1});
 
tbl = countEachLabel(pxds);
frequency = tbl.PixelCount/sum(tbl.PixelCount);
imageFreq = tbl.PixelCount ./ tbl.ImagePixelCount;
classWeights = median(imageFreq) ./ imageFreq;
imageSize=size(I);
numClasses=numel(classes);
lgraph = deeplabv3plusLayers(imageSize, numClasses, "resnet50");

numberOfLayers = numel(lgraph.Layers);
 
pxLayer = pixelClassificationLayer('Name','labels','ClassNames',tbl.Name,'ClassWeights',classWeights);
lgraph = replaceLayer(lgraph,"classification",pxLayer);
datasource = pixelLabelImageSource(imds,pxds);
opts = trainingOptions('sgdm', ...
    'InitialLearnRate',1e-1, ...
    'MaxEpochs',10, ...
    'MiniBatchSize',16, ...
    'ExecutionEnvironment','cpu', ...
    'Plots','training-progress');
tic
[my_R50,info] = trainNetwork(datasource,lgraph,opts);
toc
save my_R50 my_R50

